=== python/requirements.txt ===
# After updating this file, run:
# $ bazel run //tools/python:requirements.update

jinja2
matplotlib
mkdocs
numpy
opencv-python
osqp
pkginfo
pygobject
requests
scipy
shapely
validators
yapf

# TODO(phil): Migrate to absl-py. These are abandoned as far as I can tell.
python-gflags
glog
