=== rawrtc/usrsctp/debian/control ===
Source: libusrsctp
Maintainer: Michael Tüxen <tuexen@fh-muenster.de>
Section: net
Priority: optional
Build-Depends: cmake,
               debhelper (>= 9),
               libfile-fcntllock-perl
Standards-Version: 3.9.8
Vcs-Browser: https://github.com/sctplib/usrsctp
Vcs-Git: https://github.com/sctplib/usrsctp.git
Homepage: https://github.com/sctplib/usrsctp

Package: libusrsctp1
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Portable SCTP Userland Stack
 This is a userland SCTP stack supporting FreeBSD, Linux, Mac OS X and Windows.
 .
 This package contains the shared library for the Portable SCTP Userland Stack.

Package: libusrsctp-dev
Architecture: any
Depends: libusrsctp1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Portable SCTP Userland Stack (Development Files)
 This is a userland SCTP stack supporting FreeBSD, Linux, Mac OS X and Windows.
 .
 This package contains the development files for the Portable SCTP Userland Stack.

Package: libusrsctp-examples
Architecture: any
Depends: libusrsctp1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Portable SCTP Userland Stack (Examples)
 This is a userland SCTP stack supporting FreeBSD, Linux, Mac OS X and Windows.
 .
 This package contains the examples for the Portable SCTP Userland Stack.
